require 'test_helper'

class SmsSpeedwayApiTest < ActiveSupport::TestCase

  test "truth" do
    assert_kind_of Module, SmsSpeedwayApi
  end

 def test_set_company
     xx= SmsSpeedwayApi::SMS.new
     xx.company="abc"
     assert_equal "abc", xx.company
 end
 
 def test_set_user
     xx= SmsSpeedwayApi::SMS.new
     xx.username="userabc"
     assert_equal "userabc", xx.username
 end
 
 def test_set_password
     xx= SmsSpeedwayApi::SMS.new
     xx.password="passabc"
     assert_equal "passabc", xx.password
 end
 
 def test_testmode
     xx= SmsSpeedwayApi::SMS.new
     assert_equal xx.testmode, false
     assert_equal "http://www.sms-speedway.com/queue_sms.php?", xx.speedwayUrl

     xx.testmode=true
     assert_equal xx.testmode, true
     assert_equal "http://dev.sms-speedway.com/queue_sms.php?TESTMODE=1&", xx.speedwayUrl
 end

 def test_send_with_no_dest
     xx= SmsSpeedwayApi::SMS.new
     xx.password="passabc"
     assert_equal "passabc", xx.password
 end

 def test_validate_message
     xx= SmsSpeedwayApi::SMS.new

     ret=xx.validate_message
     assert_equal ret.code, 1
     assert_equal "Message is empty", ret.message 

     xx.message="abc"
     ret=xx.validate_message
     assert_equal ret.code, 0
 end

 def test_validate_numbers
     xx= SmsSpeedwayApi::SMS.new

     ret=xx.validate_numbers
     assert_equal ret.code, 2
     assert_equal "No numbers to send to", ret.message

     xx.numbers=["07973000000"]
     ret=xx.validate_numbers
     assert_equal ret.code, 0
 end

 def test_validate_login
     xx= SmsSpeedwayApi::SMS.new

     ret=xx.validate_login
     assert_equal ret.code, 3
     assert_equal "Company ID is missing", ret.message

     xx.company="company1" 
     ret=xx.validate_login
     assert_equal ret.code, 4
     assert_equal "User ID is missing", ret.message

     xx.username="user1" 
     ret=xx.validate_login
     assert_equal ret.code, 5
     assert_equal "Password is missing", ret.message

     xx.password="abc123" 
     ret=xx.validate_login
     assert_equal ret.code, 0
     assert_equal "", ret.message
 end
 
 def test_numbers_as_string
     xx= SmsSpeedwayApi::SMS.new
     assert_equal "", xx.numbers_as_string

     xx.numbers=["07973000000"]
     assert_equal "07973000000", xx.numbers_as_string

     xx.numbers=["07973000000", "07973000001", "07973000002"]
     assert_equal "07973000000,07973000001,07973000002", xx.numbers_as_string
 end

 def test_get_url
     xx= SmsSpeedwayApi::SMS.new

     xx.numbers=["07973000000"]
     xx.message="Test message"
     xx.company="company1" 
     xx.username="user1"
     xx.password="abc123"

     assert_equal "http://www.sms-speedway.com/queue_sms.php?message=Test%20message&company=company1&login=user1&password=abc123&numbers=07973000000", xx.getURL
 end

 def test_send
     xx= SmsSpeedwayApi::SMS.new

     ret= xx.send
     assert_not ret.success?
     assert_equal "Message is empty", ret.message
     assert_equal ret.code, 1

     xx.message="Test message"
     assert_equal "Test message", xx.message

     ret= xx.send
     assert_equal "No numbers to send to", ret.message
     assert_equal ret.code, 2

     xx.numbers=["07973000000"]
     assert_equal ["07973000000"], xx.numbers
     ret= xx.send
     assert_equal  3, ret.code
     assert_equal "Company ID is missing", ret.message

     xx.company="company1" 
     xx.username="user1" 
     xx.password="abc123" 
     ret= xx.send

     assert_equal 100,ret.code
     assert_equal "*** LOGIN FAILURE ***", ret.message
 end

# def test_real
     # Put in your own live credentials here
#     xx= SmsSpeedwayApi::SMS.new
#     xx.message="Test message"
#     xx.numbers=["xxxxxxxxxxx"]
#     xx.company="xxxxxx" 
#     xx.username="xxxxxxxx"
#     xx.password="xxxxxxxxx" 

#     ret= xx.send

#     assert_equal 0,ret.code

# end
 
end
